//control so we can have multiple stickies!

include("OfficeSpaceSticky.js");

numStickies = 0;
myStickies = new Array();

//name is an optional parameter
function addSticky(name)
{
    numStickies++;
    
    //create a name based on the current time... no dups!
    if( name == null)
        name = "s" + (new Date().getTime());
    
    log("addSticky(" + name + ")");
    
    var sticky = this[name] = new OfficeSpaceSticky(name);
    
    //put it in our array and give it an index
    myStickies.push(name);
    sticky._index = numStickies-1;
    
    //add a menu item to this sticky so we can add/remove other stickies from contextual menu
    var items = new Array();
    items[2] = new MenuItem();
    items[2].enabled = true;
    items[2].title = "Add Another Sticky";
    items[2].onSelect = "addSticky()";
    
    items[3] = new MenuItem();
    items[3].enabled = true;
    items[3].title = "Close This Sticky";
    items[3].onSelect = sticky.myName + ".close()";

    sticky.myWin.contextMenuItems = items;
    
    //give it a '+' image for mutliple stickies
    sticky.myPB = new Image(sticky.myWin);
    sticky.myPB.src = "Resources/Images/plus-up.png";
    sticky.myPB.tracking = "rectangle";
    sticky.myPB.onMouseUp = "addSticky();";
    sticky.myPB.onMouseEnter = sticky.myName + ".onPBMouseEnter()";
    sticky.myPB.onMouseExit = sticky.myName + ".onPBMouseExit()";
    
    //when mouse enters the plus button
    sticky.onPBMouseEnter = function()
    {
    	this.myPB.src = "Resources/Images/plus-over.png";
    }
    
    //when mouse exits the plus button
    sticky.onPBMouseExit = function()
    {
    	this.myPB.src = "Resources/Images/plus-up.png";
    }
    
    //copy the close function (so we can override it)
    sticky._close = sticky.close;
    //copy the draw function (so we can override it)
    sticky._draw = sticky.draw;
    
    //override their close function (to keep track of the # of stickies)
    sticky.close = function()
    {
        //close it only if they really want to close it (the dialog box...)
		if( !this._close() )
		  return;
		
		//remove this sticky from our list of stickies
		myStickies.splice( this._index, 1 );
		
		//this is what we modify
		numStickies--;
		
		if( numStickies == 0 )
		  addSticky();
    }
    
    //override the draw function (to draw a '+' sign for multiple stickies)
    sticky.draw = function()
    {
        this._draw();
        
        //draw the plus
        this.myPB.hOffset = 0;
        this.myPB.vOffset = this.myWin.height - this.myPB.height;
        updateNow();
    }
    
    sticky.draw();  //redraw
    
    return sticky;
}

//save our stickies
function saveStickies()
{
    //save prefs of individual stickies
    for( var i = 0; i < myStickies.length; i++ )
        eval(myStickies[i]).savePrefs();
    
    //save the group of stickies
    preferences.stickies_list.value = myStickies.join(",");
    log( "Saved Stickies: " + preferences.stickies_list.value );
}

//load our stickies
function loadStickies()
{
    log("loadStickies()");
    var savedStickies = preferences.stickies_list.value.split(",");
    
    log("Saved Stickies: " + myStickies.join(","));
    
    //if no saved stickies, add one now (note, even if it is empty, length will be 1)
    if( savedStickies[0] == "" )
    {
        addSticky();
        return;
    }
    
    //load saved stickies
    suppressUpdates();  //supressUpdates not working?
    for( var i = 0; i < savedStickies.length; i++ )
    {
        log("adding " + (i+1) + " of " + savedStickies.length);
        var s = addSticky( savedStickies[i] );
        
        if( s.collapsed )
            s.collapse(); 
    }
    resumeUpdates();
}

//load our stickies
loadStickies();